import waba.ui.*;
import waba.fx.*;

//##################################################################
public class ScrollTrack extends TrackControl{
//##################################################################
//==================================================================
public void doPaint(Graphics g,Rect area)
//==================================================================
{
	Rect t = getThumbArea();
	Rect r = getRect();
	g.setColor(255,255,255);
	g.fillRect(0,0,r.width,r.height);
	g.setColor(0,0,0);
	g.drawRect(0,0,r.width,r.height);
	g.fillRect(t.x,t.y,t.width,t.height);
}
//==================================================================
public ScrollTrack(int st) {type = st;}
//==================================================================
Point thumbPos = new Point();
int thumbThickness = 10;

public Rect getThumbArea()
{
	if (thumbThickness == 0) return new Rect(-100,-100,1,1);
	int w = thumbThickness, h = thumbThickness;
	if (type == Horizontal) h = getRect().height;
	else w = getRect().width;
	return new Rect(thumbPos.x,thumbPos.y,w,h);
}
public void setThumbPos(int x,int y)
{
	Rect r = getRect();
	if (type == Horizontal) {
		y = 0;
		int max = r.width-thumbThickness;
		if (x > max) x = max;
		if (x < 0) x = 0;
	}else{
 		x = 0;
		int max = r.height-thumbThickness;
		if (y > max) y = max;
		if (y < 0) y = 0;
	}
	thumbPos.move(x,y);
}
public void generate(int what,int value)
{
	postEvent(new mScrollEvent(this,what,value));
	//System.out.println(what+","+value);
}

protected int visible, actual, current, scrollable;

//==================================================================
public void recalculate()
//==================================================================
{
	Rect r = getRect();
	if (visible >= actual) thumbThickness = 0;
	scrollable = actual-visible;
	int max = r.width;
	if (type == Vertical) max = r.height;
	//System.out.println(visible+" "+actual+" "+current+" "+max);
	if (scrollable == 0) scrollable = 10;
	if (actual == 0) actual = 10;
	thumbThickness = (visible*max)/actual;
	//System.out.println(visible+" "+actual+" "+max+" "+thumbThickness);
	if (thumbThickness < 5) thumbThickness = 5;
	if (thumbThickness > max) thumbThickness = max;
	int pos = (current*(max-thumbThickness))/scrollable;
	if (!amTracking)
		if (type == Vertical) setThumbPos(0,pos);
		else setThumbPos(pos,0);
}
//==================================================================
public void setRect(int x,int y,int w,int h)
//==================================================================
{
	super.setRect(x,y,w,h);
	recalculate();
}
//==================================================================
public void resizeTo(int width,int height)
//==================================================================
{
	setRect(x,y,width,height);
}
//==================================================================
public void setPositions(int vs,int ac,int cur,boolean repaint)
//==================================================================
{
	if (visible == vs && actual == ac && current == cur) return;
	visible = vs;
	actual = ac;
	current = cur;
	recalculate();
	if (!amTracking && repaint) repaintNow();
}
//==================================================================
public int getTrackTo()
//==================================================================
{
	Rect r = getRect();
	int max = r.width, cp = thumbPos.x;
	if (type == Vertical) {
		max = r.height;
		cp = thumbPos.y;
	}
	int avail = max-thumbThickness;
	if (avail == 0 || cp == 0) return 0;
	if (cp == avail) return scrollable;
	return (cp*scrollable)/avail;
}
//##################################################################
}
//##################################################################

