import waba.ui.*;
import waba.fx.*;
import waba.sys.*;

//##################################################################
public class ScrollableContainer extends Container implements ScrollServer{
//##################################################################

ScrollClient client = null;
mScrollBar vertical,horizontal;
public boolean blockUpdate = false;
public int barWidth = 15;

//==================================================================
public ScrollableContainer(ScrollClient cl,int scrolls)
//==================================================================
{
	client = cl;
	cl.setServer(this);
	add((Control)client);
	if ((scrolls & Vertical) != 0) add(vertical = new mScrollBar(Vertical));
	if ((scrolls & Horizontal) != 0) add(horizontal = new mScrollBar(Horizontal));
}
//==================================================================
public void updateScroll(int which)
//==================================================================
{
	if (blockUpdate) return;
	int ac = client.getActual(which);
	int vs = 0;
	if (which == Horizontal){
		if (horizontal == null) return;
	 	vs = ((Control)client).getRect().width;
	}
	else if (which == Vertical) {
		if (vertical == null) return;
		vs = ((Control)client).getRect().height;
	}
	vs = client.getVisible(which,vs);
	setScroll(which,vs,ac,client.getCurrent(which));
}
//==================================================================
public void setScroll(int which,int v,int a,int c)
//==================================================================
{
	mScrollBar sb = vertical;
	if (which == Horizontal) sb = horizontal;
	sb.set(v,a,c,true);
}
//==================================================================
public void checkScrolls()
//==================================================================
{
	updateScroll(Horizontal);
	updateScroll(Vertical);
}
//==================================================================
public void setRect(int x,int y,int w,int h)
//==================================================================
{
	super.setRect(x,y,w,h);
	int cw = w;
	if (vertical != null) cw -= barWidth;
	int ch = h;
	if (horizontal != null) ch -= barWidth;
	((Control)client).setRect(0,0,cw,ch);
	if (vertical != null) vertical.setRect(w-barWidth,0,barWidth,ch);
	if (horizontal != null) horizontal.setRect(0,h-barWidth,cw,barWidth);
	checkScrolls();
}
//==================================================================
public void onEvent(Event e)
//==================================================================
{
	if (e instanceof mScrollEvent) {
		mScrollEvent se = (mScrollEvent)e;
		if (se.target == horizontal) client.doScroll(Horizontal,se.action,se.value);
		else if (se.target == vertical) client.doScroll(Vertical,se.action,se.value);
	}else
		super.onEvent(e);
}

//##################################################################
}
//##################################################################

