import waba.ui.*;
import waba.fx.*;
import waba.sys.*;

/**
* ScrollableTextArea by Michael L Brereton, November 1999.
* This code may be freely used, modified and redistributed, as long
* as credit is given to the original author in any such modification
* or distribution.
*/
//##################################################################
public class ScrollableTextArea extends TextArea implements ScrollClient{
//##################################################################

//==================================================================
// This is the implementation of ScrollClient. Remove this if ScrollBars
// are not needed.
//==================================================================
protected ScrollServer ss;
protected boolean amScrolling;
//==================================================================
public void setServer(ScrollServer server) {ss = server; amScrolling = true; homeCursorOnLostFocus = false;}
//==================================================================
public int getActual(int which)
//==================================================================
{
	if (which == IScroll.Vertical) return getNumLines();
	else {
		//return 
		int ac = getTextWidth();
		if (ac == 0) ac = 1;
		return ac;
	}
}
//==================================================================
public int getVisible(int which,int forSize)
//==================================================================
{
	if (which == IScroll.Vertical) {
		int h = getItemHeight();
		if (h != 0) return (forSize-spacing*2)/h;
		else return 1;//5;
	}
	else return forSize-spacing*2;
}
//==================================================================
public int getCurrent(int which)
//==================================================================
{
	if (which == IScroll.Vertical) return curState.firstLine;
	else return curState.xShift;
}
//==================================================================
public void checkScrolls() {if (ss != null) ss.checkScrolls();}
//==================================================================
protected void updateScrolls()
//==================================================================
{
	if (ss == null) return;
	ss.updateScroll(Horizontal);
	ss.updateScroll(Vertical);
}
//==================================================================
public ScrollableContainer getScrollableContainer()
//==================================================================
{
	return new ScrollableContainer(this,Vertical|Horizontal);
}
//##################################################################
}
//##################################################################

